'''Frame management
'''
import os
allFramesDetails={}
allFramesLoaded={}
FPS_FRAME=12
	
def getImageRowCol(imageName):
	return allFramesDetails[imageName]['row,col']

def getImageFramesNumbers(imageName, action='default'):
	return allFramesDetails[imageName][action]

def getImageActionsNames(imageName):
	actions=allFramesDetails[imageName].keys()
	actions.remove('row,col')
	return actions

def getImagesNames():
	return allFramesDetails.keys()

def getImageFrames(imageName):
	try:
		return allFramesLoaded[imageName]
	except KeyError:
		print('!!! MISSING FILE: '+str(imageName)+' !!!')
		return allFramesLoaded['miss_image.png']
	
def getImageFramesForAction(imageName, action='default'):
	try:
		return allFramesLoaded[imageName][action]
	except KeyError:
		print('Warning: missing file {filename}'.format(filename=imageName))
		return allFramesLoaded['miss_image.png']['default']

'''for every image specify the name, total frames per row and column, and the frames belonging to every action, as in the sample:

imageName='sample.png'
allFramesDetails[imageName]={}
allFramesDetails[imageName]['row,col']=[8,6] #8 rows, each one containing 6 frames
allFramesDetails[imageName]['default']=[1]
allFramesDetails[imageName]['default']=[1]
allFramesDetails[imageName]['win']=[1,2,3]
allFramesDetails[imageName]['lose']=[1,4,5]
allFramesDetails[imageName]['walk']=[6,7,8]
allFramesDetails[imageName]['fight_defense']=[15,16,15]
allFramesDetails[imageName]['fight_attack_hit']=[15,17,18,17,15]
allFramesDetails[imageName]['fight_attack_fail']=[15,17,19,17,15]
allFramesDetails[imageName]['fight_hit']=[15,20,15]
etc etc...
'''

def loadAllFramesDetails():
	print('Loading game images...')
	imageName='miss_image.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[1,1]
	allFramesDetails[imageName]['default']=[1]
	
	imageName='obj_n_nemesis.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[5,4]
	allFramesDetails[imageName]['default']=[4]
	allFramesDetails[imageName]['hit']=[17,3,19,4]
	for dir in ['l','r','u','d']:
		allFramesDetails[imageName]['default'+dir]=[1+['l','r','u','d'].index(dir)]
		allFramesDetails[imageName]['walk'+dir]=[1+['l','r','u','d'].index(dir)]
		allFramesDetails[imageName]['sword'+dir]=[5+['l','r','u','d'].index(dir)]
		allFramesDetails[imageName]['torch'+dir]=[9+['l','r','u','d'].index(dir)]
		allFramesDetails[imageName]['shield'+dir]=[13+['l','r','u','d'].index(dir)]
		allFramesDetails[imageName]['immune'+dir]=[17+['l','r','u','d'].index(dir)]

	imageName='obj_ring.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[1,2]
	allFramesDetails[imageName]['default']=[1]
	allFramesDetails[imageName]['selected']=[2]
	
	imageName='obj_combos.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[4,4]
	allFramesDetails[imageName]['default']=[1]
	for c in range(16):
		allFramesDetails[imageName][str(c/4)+str(c%4)]=[c+1]
		
	imageName='obj_elements.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[2,4]
	allFramesDetails[imageName]['default']=[1]
	for i in range(8):
		allFramesDetails[imageName][str(i+1)]=[i+1]

	imageName='obj_bullets.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[2,4]
	allFramesDetails[imageName]['default']=[1,2]
	allFramesDetails[imageName]['fireyellow']=[1,2]
	allFramesDetails[imageName]['firewhite']=[3,4]
	allFramesDetails[imageName]['fireblack']=[5,6]

	imageName='obj_RY_door.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[2,4]
	allFramesDetails[imageName]['default']=[1]	
	allFramesDetails[imageName]['closeR']=[1]
	allFramesDetails[imageName]['openR']=[2]
	allFramesDetails[imageName]['closeY']=[3]
	allFramesDetails[imageName]['openY']=[4]		
	
	
	for imageName in ('obj_a_statue.png','obj_b_bush.png', 'obj_r_rock.png'):
		allFramesDetails[imageName]={}
		allFramesDetails[imageName]['row,col']=[2,4]
		allFramesDetails[imageName]['default']=[3]
		for i in range(8):
			allFramesDetails[imageName][str(i)]=[i+1]

	imageName='obj_c_cupido.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[4,4]
	allFramesDetails[imageName]['default']=[1]
	allFramesDetails[imageName]['hit']=[5]
	allFramesDetails[imageName]['death']=[9]	

	imageName='obj_d_doorhell.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[2,1]
	allFramesDetails[imageName]['default']=[1]	
	allFramesDetails[imageName]['closeE']=[1]
	allFramesDetails[imageName]['openE']=[2]

	imageName='obj_e_ecatonchiri.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[2,4]
	allFramesDetails[imageName]['default']=[1,2,1,1]
	allFramesDetails[imageName]['hit']=[5]
	allFramesDetails[imageName]['attack']=[1,2,1,3,4]
	allFramesDetails[imageName]['death']=[6]


	imageName='obj_f_flower.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[4,4]
	allFramesDetails[imageName]['default']=[1,2,3]	
	allFramesDetails[imageName]['hit']=[5,6,7]
	allFramesDetails[imageName]['death']=[13,14,15]
	
	imageName='obj_g_soul.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[2,4]
	allFramesDetails[imageName]['default']=[1,2,3]	
	allFramesDetails[imageName]['hit']=[1]
	allFramesDetails[imageName]['death']=[1]	
	
	imageName='obj_h_torch.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[2,4]
	allFramesDetails[imageName]['default']=[1,2,3]	

	imageName='obj_i_cerbero.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[2,2]
	allFramesDetails[imageName]['default']=[2]	
	allFramesDetails[imageName]['hit']=[1]
	allFramesDetails[imageName]['death']=[3]	
	allFramesDetails[imageName]['attack']=[1,2,1,4]		

	imageName='obj_j_arpia.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[2,4]
	allFramesDetails[imageName]['default']=[1,2]
	allFramesDetails[imageName]['hit']=[2]	
	allFramesDetails[imageName]['death']=[2]		

	imageName='obj_k_centauro.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[1,2]
	allFramesDetails[imageName]['default']=[1,2]
	allFramesDetails[imageName]['hit']=[2]	
	allFramesDetails[imageName]['death']=[2]
	
	imageName='obj_l_lotofago.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[2,4]
	allFramesDetails[imageName]['default']=[1,2,3,4]	
	allFramesDetails[imageName]['hit']=[1]	
	allFramesDetails[imageName]['death']=[4]	
	
	
	imageName='obj_m_sirena.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[2,4]
	allFramesDetails[imageName]['default']=[1,2]	
	allFramesDetails[imageName]['hit']=[1,2]	
	allFramesDetails[imageName]['death']=[1,2]	
	allFramesDetails[imageName]['attack']=[3]
	
	imageName='obj_q_potfake.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[1,3]
	allFramesDetails[imageName]['default']=[1]

	imageName='obj_q_cave_monster.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[3,2]
	allFramesDetails[imageName]['default']=[1,2]	
	allFramesDetails[imageName]['hit']=[3,4]
	allFramesDetails[imageName]['death']=[5,6]	
	
	imageName='obj_o_owl.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[1,4]
	allFramesDetails[imageName]['default']=[1]
	allFramesDetails[imageName]['gone']=[2]
	allFramesDetails[imageName]['free']=[3,4]	
	
	imageName='obj_s_satiro.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[2,4]
	allFramesDetails[imageName]['default']=[1,2]
	allFramesDetails[imageName]['hit']=[1]
	allFramesDetails[imageName]['death']=[1]	
	
	imageName='obj_t_tree.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[1,5]
	allFramesDetails[imageName]['default']=[1]		
	for i in range(5):
		allFramesDetails[imageName][str(i)]=[i+1]

	
	imageName='obj_t_tip.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[2,4]
	allFramesDetails[imageName]['default']=[1,1,1,1,1,2,3,2,1,2,1,1,2,3,2]		
	allFramesDetails[imageName]['hit']=[1]
	allFramesDetails[imageName]['death']=[1]		


	imageName='obj_v_bat.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[2,4]
	allFramesDetails[imageName]['default']=[1,2]
	allFramesDetails[imageName]['hit']=[1]
	allFramesDetails[imageName]['death']=[1]	

	
	imageName='obj_w_minotauro.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[1,2]
	allFramesDetails[imageName]['default']=[1,2]
	allFramesDetails[imageName]['hit']=[2]	
	allFramesDetails[imageName]['death']=[2]
	
	imageName='obj_z_ade.png'
	allFramesDetails[imageName]={}
	allFramesDetails[imageName]['row,col']=[2,2]
	allFramesDetails[imageName]['default']=[1,2]
	allFramesDetails[imageName]['hit']=[1]	
	allFramesDetails[imageName]['death']=[1]
	allFramesDetails[imageName]['attack']=[1,2,1,3,4]	

	

