'''Game main module.
'''
import sys, pygame, random, math, os, time, traceback, copy
import ftg_dataloader, ftg_resolution, ftg_frames, ftg_level, ftg_object
import pw16_level as customLevel
from pw16_variable import *
from pygame.locals import *
pygame.init()
pygame.font.init()
pygame.mouse.set_visible(MOUSE_VISIBLE)

os.environ['SDL_VIDEO_CENTERED'] = '1'
clock = pygame.time.Clock()

screen=ftg_resolution.setResolution(WINDOW_SIZE)
pygame.display.set_caption(GAME_TITLE)
pygame.display.set_icon(ftg_dataloader.load_image('icon.png'))
ftg_frames.loadAllFramesDetails()

if MUSIC_FLAG:
	ftg_dataloader.load_music(MUSIC_FILENAME)

	
	
########################################
def mainLoop(currentLevel):  
	screen.fill([0,0,0])
	screen.blit(currentLevel.backgroundImage, (0,0))	
	#level loop
	while currentLevel.levelCompleted==False and currentLevel.quitGame==False:
		try:
			clock.tick(FPS) 
			#manage key events
			for event in pygame.event.get():
				currentLevel.eventsManagement(event)				
			
			#update objects
			currentLevel.update()

			#draw background and objects
			if issubclass(currentLevel.__class__,ftg_level.LevelWithFullScreenRefresh):
				screen.blit(currentLevel.backgroundImage, (0,0))
				for spr in currentLevel.levelSprites:
					screen.blit(spr.image,spr.rect.topleft)
			else:	
				currentLevel.levelSprites.clear(screen, currentLevel.backgroundImage)
				pygame.display.update(currentLevel.levelSprites.draw(screen))

			#draw FPS
			if currentLevel.debugOn:
				screen.blit(NORMAL_CUSTOMFONT.render('FPS '+str(round(clock.get_fps(),1)), True, pygame.Color('Black'), pygame.Color('White')).convert_alpha(), (0,0))
			
			#refresh screen
			pygame.display.flip()
		except:
			raise
			FATALERROR=True
			errorfile=open('errors.log', 'a')
			errorfile.write('-----FATAL ERRROR-----'+'\n'+str(time.localtime())+'\n')
			traceback.print_exc(file=errorfile)
			print '-------------------------------------\nFATAL ERRROR. Please check errors.log\n-------------------------------------'
			break
	return currentLevel



		
def resetGame():
	inventory=copy.deepcopy(initial_inventory)
	return inventory
	
def main():
	currentLevel=None
	nextLevel=SPLASHSCREEN
	FATALERROR=False
		
	#animations dictionary stores images to be used in every level
	animations={}

	#inventory stores data across different levels (e.g. lives, point, etc...)
	inventory=ftg_dataloader.loadGameFromFile()
	if inventory==None:
		inventory=resetGame()
		
	
	while not FATALERROR:
		#create new level
		currentLevel=customLevel.createLevel(screen,nextLevel,animations,inventory)
		
		#main loop
		try:
			currentLevel=mainLoop(currentLevel)
		except:
			print traceback.format_exc()
			traceback.print_exc(file=open("error.log","a"))
			sys.exit(1)

		try:
			inventory=currentLevel.inventory
			#ftg_dataloader.saveGameOnFile(inventory)
		except:
			print 'ERROR - resetting game'
			inventory=resetGame()
		
		if currentLevel.quitGame:
			sys.exit('Pressed ESC')
		#change level
		nextLevel=currentLevel.nextLevel





