import os
import ftg_dataloader#, pw16_objects as customObjects
import pygame
from pygame.locals import *
pygame.font.init()

###############
# WINDOW SIZE #
###############
#Game is supposed to run in a window having 2:3 aspect ratio
#Please uncomment one of the suggested resolutions:
#WINDOW_SIZE=(400,300)
WINDOW_SIZE=(800,600)
#WINDOW_SIZE=(960,720)

#Set to True to play Fullscreen
FULLSCREEN=False


############
# CONTROLS #
############
#Edit with the KeyASCII you want to use (refer to http://www.pygame.org/docs/ref/key.html)
#Please do not use the following keys since they are already used for different purposes:
#K_ESCAPE, K_RETURN, K_BACKSPACE, K_F12
MOVE_LEFT=[K_LEFT]
MOVE_RIGHT=[K_RIGHT]
MOVE_UP=[K_UP]
MOVE_DOWN=[K_DOWN]
ACTION=[K_LCTRL]
COMBINE=[K_1,K_2,K_3,K_4,K_5,K_6,K_7,K_8]
EXECUTE=[K_SPACE]


#######
# FPS #
#######
#Screen flips per seconds
FPS = 60
#Number of screen flips needed to change frame in animations
FPS_FRAME=FPS/5


#############
# INVENTORY #
#############
#Game initial setup. Editing these values means cheating.
initial_inventory={}
initial_inventory['lives']=9
initial_inventory['elements']=[False]*8
#initial_inventory['elements']=[True]*8 uncooment to cheat
initial_inventory['knownCombos']=[]
initial_inventory['owl']=[]
initial_inventory['boss']=[False]
initial_inventory['doors']=[False]
initial_inventory['yourPos']=[[1,5],[5,5]]




ELEMENTS=['sword','stick','flute','waxboard','plectrum','wreath','scroll','lyre']
MUSES=['melpomene','urania','euterpe','calliope','tersicore','talia','clio','erato']
#order is 0.melpomene[spada],1.urania[bastone],2.euterpe[flauto],3.calliope[tavoletta di cera],4.tersicore[plettro],5.talia[ghirlanda],6.clio[pergamena],7.erato[lira]

COMBOS=[]
COMBOS.append(['sword','fireyellow','shield','fireblack']) 	#1-5 1-6 1-7 1-8
COMBOS.append(['keyred','milk','keyyellow','speed']) 		#2-
COMBOS.append(['firewhite','money','torch','invisible'])	#3-
COMBOS.append(['freeowl','immune','read','keyhell'])		#4-
















########################################
# PLEASE DO NOT EDIT THE SECTION BELOW #
########################################
#Changing these values may lead to unplayable game

DEBUG_FLAG=False
MUSIC_FLAG=True
GAME_TITLE='Nemesis- Forked Tail Team - PyWeek#16'
MUSIC_FILENAME='sacred-cobolt-candidum.mp3'
MOUSE_VISIBLE=True
CUSTOMFONT='diogenes.ttf'
BIG_CUSTOMFONT=pygame.font.Font(ftg_dataloader.load_font(CUSTOMFONT), WINDOW_SIZE[1]/12)
NORMAL_CUSTOMFONT=pygame.font.Font(ftg_dataloader.load_font(CUSTOMFONT), WINDOW_SIZE[1]/24)
SMALL_CUSTOMFONT=pygame.font.Font(ftg_dataloader.load_font(CUSTOMFONT), WINDOW_SIZE[1]/28)
GREEK_FONT=pygame.font.Font(ftg_dataloader.load_font('geek.ttf'), WINDOW_SIZE[1]/28)

#layer order
#object are draw on screen with layers according to the order in the following list

'''
SORTED_LAYERS=[customObjects.Sun,
			customObjects.Mercury,customObjects.Venus,customObjects.Earth,customObjects.Mars,
			customObjects.Jupiter,customObjects.Saturn,customObjects.Uranus,customObjects.Neptune,
			customObjects.Pluto,
			#customObjects.Moon,
			#customObjects.Asteroid,
			#customObjects.Seed,
			#customObjects.Snow,
			#customObjects.LevelMask,
			#customObjects.OrbitLine,
			#customObjects.PlanetInfo,
			#customObjects.Overprint,
			#customObjects.GameText,
			#customObjects.LevelTimer
			]
'''			




#game related constants


'''
#level IDs
CREDITS=-7
WINSCREEN=-6
GAMEOVER=-5
PAUSESCREEN=-4
SPLASHSCREEN=-3
TITLESCREEN=-2
GAMEINTRO=-1
LEVELLIST=0
#game level ID

'''
#level IDs
##########
SPLASHSCREEN=-5
#exception jumps to TITLESCREEN
GAMEOVER=-3
TITLESCREEN=-2
GAMEINTRO=-1 #story

###########
NEMESIS=0
YOUWIN=1
#any exception will jump to TITLESCREEN


BLACKROOMS=[[5,1],[5,4],[7,0],[9,6]]

READING=[[[False,'']]*10]*10
READING[0][8]=[True,'Only the black shot can defeat Ades']
READING[1][5]=[True,'Free every owls']
READING[2][0]=[True,'Urania and Erato make you faster']
READING[2][9]=[True,'Stand a little out of my sun']
READING[3][3]=[True,'Credits: Code - il seppia, art - circusblatta']
READING[5][1]=[True,'Panta rei']
READING[5][3]=[True,'My name is Nobody']
READING[5][4]=[True,'Glass maze']
READING[5][8]=[True,'Ulysses was here']
READING[6][0]=[True,'The end is nigh']
READING[6][2]=[True,'Enea was here']
READING[7][0]=[True,'Pain']
READING[7][3]=[True,'Erato and Calliope will open the gate of hell for you']
READING[7][6]=[True,'Made by Apelle']
READING[9][4]=[True,'Non plus ultra']